AutoCAD .Net 创建椭圆Ellipse

以下代码展示:
往模型空间中添加一个椭圆。椭圆的中心为(0, 0, 0),长轴半径为100,短轴半径为60,圆弧所在平面为XOY平面,起始角为0度,终止角为360度。
设置椭圆的图层、颜色、线型、线宽请参考文章AutoCAD .Net 创建直线Line

using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Colors;

[CommandMethod("NewEllipse")]
public static void NewEllipse()
{
    Document doc = Application.DocumentManager.MdiActiveDocument;
    Database db = doc.Database;

    using (Transaction tr = db.TransactionManager.StartTransaction())
    {
        //-------------------------------
        // 获取模型空间
        //-------------------------------
        BlockTable blockTbl = tr.GetObject(
            db.BlockTableId, OpenMode.ForRead) as BlockTable;
        BlockTableRecord modelSpace = tr.GetObject(
            blockTbl[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;

        //-------------------------------
        // 创建椭圆
        //-------------------------------
        Ellipse ellipse = new Ellipse();
        ellipse.Set(
            new Point3d(0, 0, 0),     // Center
            new Vector3d(0, 0, 1),    // Normal
            new Vector3d(100, 0, 0),  // Major Axis
            0.6,                      // Radius radio
            0,                        // Start Angle
            Math.PI * 2               // End Angle
        );

        //----------------------------
        // 添加到模型空间并提交到数据库
        //-------------------------------
        modelSpace.AppendEntity(ellipse);
        tr.AddNewlyCreatedDBObject(ellipse, true);

        tr.Commit();
    }
}

通过设置椭圆的起始角度和终止角度可以创建椭圆弧。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值